theory HandsOnI_Ideas
imports Tutorial_Basic
  "$AFP/CAVA_Automata/Digraph"
begin
  text \<open>Idea: Extend the DFS or worklist algorithm by keeping track of already 
    visited node, and thus make it work for arbitrary (cyclic) graphs\<close>

  text \<open>Helps defining well-founded relations where a set
    grows but keeps below a finite bound\<close>
  find_theorems finite_psupset

  find_theorems finite_psubset

  term "E\<^sup>*``{v0}"

  term "\<lambda>R. inv_image R snd"
  find_theorems inv_image

  term "op <*lex*>"
  term "A <*lex*> B"
  find_theorems "op <*lex*>"
  
  text \<open>Idea: Extend the DFS or worklist algorithm to return a path\<close>
  find_theorems path -- \<open>Predicate for a path between two nodes\<close>


end

